## libiio 0.10

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)
project(libiio C)

set(LIBIIO_VERSION_MAJOR 0)
set(LIBIIO_VERSION_MINOR 10)
set(VERSION "${LIBIIO_VERSION_MAJOR}.${LIBIIO_VERSION_MINOR}")

# Set the default install path to /usr
if (NOT WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
	set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "default install path" FORCE)
endif()

set(CMAKE_INSTALL_DOCDIR "" CACHE PATH "documentation root (DATAROOTDIR/doc/${PROJECT_NAME}${LIBIIO_VERSION_MAJOR}-doc)")
include(GNUInstallDirs)
set(CMAKE_INSTALL_DOCDIR "${CMAKE_INSTALL_DATAROOTDIR}/doc/${PROJECT_NAME}${LIBIIO_VERSION_MAJOR}-doc")

set(INSTALL_PKGCONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
	CACHE PATH "Installation directory for pkgconfig (.pc) files")
mark_as_advanced(INSTALL_PKGCONFIG_DIR)

if (NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
		"Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel."
		FORCE)
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS None Debug Release RelWithDebInfo MinSizeRel)
endif()

set(BUILD_SHARED_LIBS ON CACHE BOOL "Build shared libraries")

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	option(OSX_PACKAGE "Create a OSX package" ON)
	set(CMAKE_MACOSX_RPATH ON)
	set(SKIP_INSTALL_ALL ${OSX_PACKAGE})
endif()

option(WITH_NETWORK_BACKEND "Enable the network backend" ON)
option(WITH_TESTS "Build the test programs" ON)

if (WITH_TESTS)
	set(NEED_THREADS 1)
endif()

if (MSVC)
	# Avoid annoying warnings from Visual Studio
	add_definitions(-D_CRT_SECURE_NO_WARNINGS=1)

	set(CMAKE_FIND_LIBRARY_PREFIXES "lib" "")
	set(CMAKE_FIND_LIBRARY_SUFFIXES ".dll.a" ".a" ".lib")
endif()

if (NOT LOG_LEVEL)
	set(LOG_LEVEL Info CACHE STRING "Log level" FORCE)
	set_property(CACHE LOG_LEVEL PROPERTY STRINGS NoLog Error Warning Info Debug)
endif()

if (CMAKE_COMPILER_IS_GNUCC)
	if (NOT WIN32)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
	endif()

	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wno-unused-parameter -Wno-sign-compare")

	include(CheckCCompilerFlag)
	check_c_compiler_flag(-Wpedantic HAS_WPEDANTIC)
	if (HAS_WPEDANTIC)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wpedantic")
	endif()
endif()

include(CheckSymbolExists)
check_symbol_exists(strdup "string.h" HAS_STRDUP)
check_symbol_exists(strerror_r "string.h" HAS_STRERROR_R)
check_symbol_exists(newlocale "locale.h" HAS_NEWLOCALE)

IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	option(WITH_IIOD "Build the IIO Daemon" ON)
	option(WITH_LOCAL_BACKEND "Enable the local backend" ON)

	if (WITH_IIOD AND NOT WITH_LOCAL_BACKEND)
		message(SEND_ERROR "IIOD can only be enabled if the local backend is enabled")
	endif()
	if (WITH_IIOD)
		set(NEED_THREADS 1)
	endif()

	set(CMAKE_REQUIRED_DEFINITIONS "-D_GNU_SOURCE=1")
	add_definitions(-D_GNU_SOURCE=1)
endif()

option(ENABLE_IPV6 "Define if you want to enable IPv6 support" ON)
if (ENABLE_IPV6)
	check_symbol_exists(in6addr_any "netinet/in.h" HAVE_IPV6)

	if (NOT HAVE_IPV6)
		message(WARNING "IPv6 is not available in your system.")
	endif()
endif()

set(LIBIIO_CFILES backend.c channel.c device.c context.c buffer.c utilities.c scan.c)
set(LIBIIO_HEADERS iio.h)

add_definitions(-D_POSIX_C_SOURCE=200809L -D__XSI_VISIBLE=500 -DLIBIIO_EXPORTS=1)

# Get the GIT hash of the latest commit
include(FindGit OPTIONAL)
if (GIT_FOUND)
	execute_process(
		COMMAND ${GIT_EXECUTABLE} rev-parse --show-toplevel
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		OUTPUT_VARIABLE LIBIIO_GIT_REPO
		OUTPUT_STRIP_TRAILING_WHITESPACE
	)

	if (${LIBIIO_GIT_REPO} MATCHES ${CMAKE_CURRENT_SOURCE_DIR})
		execute_process(
			COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			OUTPUT_VARIABLE LIBIIO_VERSION_GIT
			OUTPUT_STRIP_TRAILING_WHITESPACE
		)
	endif()
endif()

if (NOT LIBIIO_VERSION_GIT)
	set(LIBIIO_VERSION_GIT v${VERSION})
endif()

if(WITH_LOCAL_BACKEND)
	add_definitions(-DLOCAL_BACKEND=1)
	set(LIBIIO_CFILES ${LIBIIO_CFILES} local.c)

	# Link with librt if present
	find_library(LIBRT_LIBRARIES rt)
	if (LIBRT_LIBRARIES)
		set(LIBS_TO_LINK ${LIBS_TO_LINK} ${LIBRT_LIBRARIES})
	endif()

	option(WITH_LOCAL_CONFIG "Read local context attributes from /etc/libiio.ini" OFF)
	if (WITH_LOCAL_CONFIG)
		find_library(LIBINI_LIBRARIES ini)
		find_path(LIBINI_INCLUDE_DIR ini.h)
		if (NOT LIBINI_LIBRARIES OR NOT LIBINI_INCLUDE_DIR)
			message(SEND_ERROR "WITH_LOCAL_CONFIG option requires libini to be installed")
		else()
			include_directories(${LIBINI_INCLUDE_DIR})
			set(LIBS_TO_LINK ${LIBS_TO_LINK} ${LIBINI_LIBRARIES})
		endif()
	endif()
endif()

find_library(LIBUSB_LIBRARIES usb-1.0)
find_path(LIBUSB_INCLUDE_DIR libusb-1.0/libusb.h)
if (LIBUSB_LIBRARIES AND LIBUSB_INCLUDE_DIR)
	option(WITH_USB_BACKEND "Enable the libusb backend" ON)

	if(WITH_USB_BACKEND)
		add_definitions(-DUSB_BACKEND=1)
		set(LIBIIO_CFILES ${LIBIIO_CFILES} usb.c)
		set(LIBS_TO_LINK ${LIBS_TO_LINK} ${LIBUSB_LIBRARIES})
		set(IIOD_CLIENT 1)
		set(NEED_LIBXML2 1)
		set(NEED_THREADS 1)

		include_directories(${LIBUSB_INCLUDE_DIR})
	endif()
endif()

find_library(LIBSERIALPORT_LIBRARIES serialport)
find_path(LIBSERIALPORT_INCLUDE_DIR libserialport.h)
if (LIBSERIALPORT_LIBRARIES AND LIBSERIALPORT_INCLUDE_DIR)
	option(WITH_SERIAL_BACKEND "Enable the serial backend" ON)

	if (WITH_SERIAL_BACKEND)
		file(STRINGS ${LIBSERIALPORT_INCLUDE_DIR}/libserialport.h LIBSERIALPORT_VERSION_STR REGEX "SP_PACKAGE_VERSION_STRING")
		string(REGEX REPLACE "#define SP_PACKAGE_VERSION_STRING \"(.*)\"" "\\1" LIBSERIALPORT_VERSION ${LIBSERIALPORT_VERSION_STR})
		if ("${LIBSERIALPORT_VERSION}" VERSION_LESS 0.1.1)
			message(SEND_ERROR "The installed version of libserialport is too old. The minimum version supported is 0.1.1.")
		endif()

		add_definitions(-DSERIAL_BACKEND=1)
		set(LIBIIO_CFILES ${LIBIIO_CFILES} serial.c)
		set(LIBS_TO_LINK ${LIBS_TO_LINK} ${LIBSERIALPORT_LIBRARIES})

		set(NEED_THREADS 1)
		set(IIOD_CLIENT 1)
		set(NEED_LIBXML2 1)

		include_directories(${LIBSERIALPORT_INCLUDE_DIR})
	endif()
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

if(WITH_NETWORK_BACKEND)
	if (WIN32)
		set(LIBS_TO_LINK ${LIBS_TO_LINK} wsock32 ws2_32)
	endif()

	if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
		include(CheckCSourceCompiles)
		check_c_source_compiles("#include <fcntl.h>\nint main(void) { return O_TMPFILE; }" HAS_O_TMPFILE)

		if (HAS_O_TMPFILE)
			option(WITH_NETWORK_GET_BUFFER "Enable experimental zero-copy transfers" OFF)
		endif(HAS_O_TMPFILE)

		check_c_source_compiles("#include <sys/eventfd.h>\nint main(void) { return eventfd(0, EFD_CLOEXEC | EFD_NONBLOCK); }" WITH_NETWORK_EVENTFD)
	endif()

	if(NOT WIN32)
		include(CheckCSourceCompiles)
		check_c_source_compiles("#include <unistd.h>\n#include <fcntl.h>\nint main(void) { int fd[2]; return pipe2(fd, O_CLOEXEC | O_NONBLOCK); }" HAS_PIPE2)
	endif()

	add_definitions(-DNETWORK_BACKEND=1)
	set(LIBIIO_CFILES ${LIBIIO_CFILES} network.c)

	find_library(AVAHI_CLIENT_LIBRARIES avahi-client)
	find_library(AVAHI_COMMON_LIBRARIES avahi-common)
	if(AVAHI_CLIENT_LIBRARIES AND AVAHI_COMMON_LIBRARIES)
		set(HAVE_AVAHI ON)
		set(AVAHI_LIBRARIES ${AVAHI_CLIENT_LIBRARIES} ${AVAHI_COMMON_LIBRARIES})
		set(LIBS_TO_LINK ${LIBS_TO_LINK} ${AVAHI_LIBRARIES})
	endif()

	set(NEED_THREADS 1)
	set(IIOD_CLIENT 1)
	set(NEED_LIBXML2 1)
endif()

# Since libxml2-2.9.2, libxml2 provides its own LibXml2-config.cmake, with all
# variables correctly set.
# So, try first to find the CMake module provided by libxml2 package, then fallback
# on the CMake's FindLibXml2.cmake module (which can lack some definition, especially
# in static build case).
find_package(LibXml2 QUIET NO_MODULE)
if(DEFINED LIBXML2_VERSION_STRING)
	set(LIBXML2_FOUND ON)
	set(LIBXML2_INCLUDE_DIR ${LIBXML2_INCLUDE_DIRS})
else()
	include(FindLibXml2)
endif()

if (LIBXML2_FOUND)
	option(WITH_XML_BACKEND "Enable the serial backend" ON)

	if (WITH_XML_BACKEND)
		set(LIBIIO_CFILES ${LIBIIO_CFILES} xml.c)
		add_definitions(${LIBXML2_DEFINITIONS} -DXML_BACKEND=1)
		include_directories(${LIBXML2_INCLUDE_DIR})
		set(LIBS_TO_LINK ${LIBS_TO_LINK} ${LIBXML2_LIBRARIES})
	endif()
endif()

if (NEED_LIBXML2 AND NOT (LIBXML2_FOUND AND WITH_XML_BACKEND))
	message(SEND_ERROR "The selected backends require libxml2 and the XML backend to be enabled")
endif()

if (NEED_THREADS)
	if (NOT WIN32)
		find_library(PTHREAD_LIBRARIES pthread)

		if (PTHREAD_LIBRARIES)
			set(LIBS_TO_LINK ${LIBS_TO_LINK} ${PTHREAD_LIBRARIES})
		else()
			message(WARNING "pthread library not found; support for threads will be disabled")
			set(NO_THREADS ON)
		endif()
	else()
	endif()

	set(LIBIIO_CFILES ${LIBIIO_CFILES} lock.c)
endif()

if (IIOD_CLIENT)
	set(LIBIIO_CFILES ${LIBIIO_CFILES} iiod-client.c)
endif()

configure_file(libiio.iss.cmakein ${CMAKE_CURRENT_BINARY_DIR}/libiio.iss @ONLY)

set(LIBIIO_PC ${CMAKE_CURRENT_BINARY_DIR}/libiio.pc)
configure_file(libiio.pc.cmakein ${LIBIIO_PC} @ONLY)

if(NOT SKIP_INSTALL_ALL)
	install(FILES ${LIBIIO_PC} DESTINATION "${INSTALL_PKGCONFIG_DIR}")
endif()

#set(SETUP_PY ${CMAKE_CURRENT_SOURCE_DIR}/bindings/python/setup.py)
#configure_file(python/setup.py.in ${SETUP_PY} @ONLY)

add_subdirectory(bindings)

if (WITH_MATLAB_BINDINGS_API)
	set(LIBIIO_EXTRA_HEADERS ${LIBIIO_EXTRA_HEADERS} bindings/matlab/iio-wrapper.h)
	add_definitions(-DMATLAB_BINDINGS_API=1)
endif()

if(WITH_TESTS)
	add_subdirectory(tests)
endif()

add_library(iio ${LIBIIO_CFILES} ${LIBIIO_HEADERS} ${LIBIIO_EXTRA_HEADERS})
set_target_properties(iio PROPERTIES
	VERSION ${VERSION}
	SOVERSION ${LIBIIO_VERSION_MAJOR}
	FRAMEWORK TRUE
	PUBLIC_HEADER ${LIBIIO_HEADERS}
	C_STANDARD 99
	C_STANDARD_REQUIRED ON
	C_EXTENSIONS OFF
)
target_link_libraries(iio LINK_PRIVATE ${LIBS_TO_LINK})

if (MSVC)
	set_target_properties(iio PROPERTIES OUTPUT_NAME libiio)
endif()

if(NOT SKIP_INSTALL_ALL)
	install(TARGETS iio
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		FRAMEWORK DESTINATION /Library/Frameworks
		PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
endif()

find_package(Doxygen)
if(DOXYGEN_FOUND)
	option(WITH_DOC "Generate documentation with Doxygen" ON)

	if (WITH_DOC)
		configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
		set(HTML_DEST_DIR ${CMAKE_CURRENT_BINARY_DIR}/html)
		file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/doc DESTINATION ${HTML_DEST_DIR})

		add_custom_command(TARGET iio POST_BUILD
			COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
			COMMENT "Generating API documentation with Doxygen" VERBATIM
			)

		if(NOT SKIP_INSTALL_ALL)
			install(DIRECTORY ${HTML_DEST_DIR} DESTINATION ${CMAKE_INSTALL_DOCDIR})
		endif()
	endif()
else()
	message(STATUS "Doxygen not found, API documentation won't be generated")
endif()

# Create an installer if compiling for OSX
if(OSX_PACKAGE)
	set(LIBIIO_PKG ${CMAKE_CURRENT_BINARY_DIR}/libiio-${VERSION}.g${LIBIIO_VERSION_GIT}.pkg)
	set(LIBIIO_TEMP_PKG ${CMAKE_CURRENT_BINARY_DIR}/libiio-${VERSION}-temp.pkg)
	set(LIBIIO_DISTRIBUTION_XML ${CMAKE_CURRENT_BINARY_DIR}/Distribution.xml)
	set(LIBIIO_FRAMEWORK_DIR ${CMAKE_CURRENT_BINARY_DIR}/iio.framework)
	configure_file(Distribution.xml.cmakein ${LIBIIO_DISTRIBUTION_XML} @ONLY)

	find_program(PKGBUILD_EXECUTABLE
		NAMES pkgbuild
		DOC "OSX Package builder (pkgbuild)")
	mark_as_advanced(PKGBUILD_EXECUTABLE)

	find_program(PRODUCTBUILD_EXECUTABLE
		NAMES productbuild
		DOC "OSX Package builder (productbuild)")
	mark_as_advanced(PRODUCTBUILD_EXECUTABLE)

	foreach(_tool ${IIO_TESTS_TARGETS})
		list(APPEND IIO_TESTS $<TARGET_FILE:${_tool}>)
	endforeach()

	add_custom_command(OUTPUT ${LIBIIO_PKG}
		COMMAND ${CMAKE_COMMAND} -E make_directory ${LIBIIO_FRAMEWORK_DIR}/Tools
		COMMAND ${CMAKE_COMMAND} -E copy ${IIO_TESTS} ${LIBIIO_FRAMEWORK_DIR}/Tools
		COMMAND ${PKGBUILD_EXECUTABLE}

=== bindings/CMakeLists.txt ===
add_subdirectory(csharp)
add_subdirectory(matlab)
add_subdirectory(python)

=== examples/Makefile ===
# libiio - Library for interfacing industrial I/O (IIO) devices
#
# Copyright (C) 2014 Analog Devices, Inc.
# Author: Paul Cercueil <paul.cercueil@analog.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.


TARGETS := ad9361-iiostream dummy-iiostream iio-monitor

CFLAGS = -Wall

UNAME_S := $(shell uname -s)

ifeq ($(UNAME_S),Darwin)
	CFLAGS += -framework iio
else
	LDFLAGS += -liio
endif

.PHONY: all clean

all: $(TARGETS)

iio-monitor: iio-monitor.o
	$(CC) -o $@ $^ $(CFLAGS) $(LDFLAGS) -lpthread -lncurses -lcdk

ad9361-iiostream : ad9361-iiostream.o
	$(CC) -o $@ $^ $(CFLAGS) $(LDFLAGS)

dummy-iiostream : dummy-iiostream.o
	$(CC) -o $@ $^ $(CFLAGS) $(LDFLAGS)

clean:
	rm -f $(TARGETS) $(TARGETS:%=%.o)

=== iiod/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)
project(iiod C)

include(FindBISON)
include(FindFLEX)

flex_target(lexer
	${CMAKE_CURRENT_SOURCE_DIR}/lexer.l ${CMAKE_CURRENT_BINARY_DIR}/lexer.c)
bison_target(parser
	${CMAKE_CURRENT_SOURCE_DIR}/parser.y ${CMAKE_CURRENT_BINARY_DIR}/parser.c)
add_flex_bison_dependency(lexer parser)
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(IIOD_CFILES iiod.c ops.c thread-pool.c ${BISON_parser_OUTPUTS} ${FLEX_lexer_OUTPUTS})

find_library(LIBAIO_LIBRARIES aio)
find_path(LIBAIO_INCLUDE_DIR libaio.h)

if (LIBAIO_LIBRARIES AND LIBAIO_INCLUDE_DIR)
	option(ENABLE_AIO "Build IIOD with async. I/O support" ON)
endif ()

include(CheckTypeSize)
set(CMAKE_EXTRA_INCLUDE_FILES linux/usb/functionfs.h)
check_type_size("struct usb_functionfs_descs_head_v2" FUNCTIONFS_V2)
set(CMAKE_EXTRA_INCLUDE_FILES)

if (HAVE_FUNCTIONFS_V2)
	OPTION(WITH_IIOD_USBD "Add support for USB through FunctionFS within IIOD" ${ENABLE_AIO})

	if (WITH_IIOD_USBD)
		if (NOT ENABLE_AIO)
			message(SEND_ERROR "USB support in IIOD requires async. I/O support")
		endif (NOT ENABLE_AIO)

		set(IIOD_CFILES ${IIOD_CFILES} usbd.c)
	endif (WITH_IIOD_USBD)
endif (HAVE_FUNCTIONFS_V2)

include(CheckSymbolExists)
set(CMAKE_REQUIRED_LIBRARIES ${PTHREAD_LIBRARIES})
check_symbol_exists(pthread_setname_np "pthread.h" HAS_PTHREAD_SETNAME_NP)
set(CMAKE_REQUIRED_LIBRARIES)

add_executable(iiod ${IIOD_CFILES})
set_target_properties(iiod PROPERTIES
	C_STANDARD 99
	C_STANDARD_REQUIRED ON
	C_EXTENSIONS OFF
)
target_link_libraries(iiod iio ${PTHREAD_LIBRARIES} ${AVAHI_LIBRARIES})

if (ENABLE_AIO)
	add_definitions(-DWITH_AIO=1)
	include_directories(${LIBAIO_INCLUDE_DIR})
	target_link_libraries(iiod ${LIBAIO_LIBRARIES})
endif ()

add_definitions(-D_GNU_SOURCE=1)

if(NOT SKIP_INSTALL_ALL)
	install(TARGETS iiod RUNTIME DESTINATION ${CMAKE_INSTALL_SBINDIR})
endif()

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)

project(iio_genxml  C)
project(iio_info    C)
project(iio_attr    C)
project(iio_readdev C)
project(iio_reg     C)

if (MSVC)
	include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../deps/wingetopt/src)
	set(GETOPT_C_FILE ${CMAKE_CURRENT_SOURCE_DIR}/../deps/wingetopt/src/getopt.c)
endif (MSVC)

add_executable(iio_genxml  iio_genxml.c   ${GETOPT_C_FILE})
add_executable(iio_info    iio_info.c     ${GETOPT_C_FILE})
add_executable(iio_attr    iio_attr.c     ${GETOPT_C_FILE})
add_executable(iio_readdev iio_readdev.c  ${GETOPT_C_FILE})
add_executable(iio_reg     iio_reg.c      ${GETOPT_C_FILE})

target_link_libraries(iio_genxml  iio)
target_link_libraries(iio_info    iio)
target_link_libraries(iio_attr    iio)
target_link_libraries(iio_readdev iio)
target_link_libraries(iio_reg     iio)

set(IIO_TESTS_TARGETS iio_genxml iio_info iio_attr iio_readdev iio_reg)

if(PTHREAD_LIBRARIES)
	project(iio_adi_xflow_check C)
	add_executable(iio_adi_xflow_check iio_adi_xflow_check.c)
	target_link_libraries(iio_adi_xflow_check iio ${PTHREAD_LIBRARIES})
	set(IIO_TESTS_TARGETS ${IIO_TESTS_TARGETS} iio_adi_xflow_check)

	target_link_libraries(iio_readdev ${PTHREAD_LIBRARIES})
endif()

set_target_properties(${IIO_TESTS_TARGETS} PROPERTIES
	C_STANDARD 99
	C_STANDARD_REQUIRED ON
	C_EXTENSIONS OFF
)

if(NOT SKIP_INSTALL_ALL)
	if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
		install(TARGETS ${IIO_TESTS_TARGETS} RUNTIME DESTINATION /Library/Frameworks/iio.framework/Tools)
	else()
		install(TARGETS ${IIO_TESTS_TARGETS} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
	endif()
endif()

# Make the test targets available to the main CMakeLists.txt
set(IIO_TESTS_TARGETS ${IIO_TESTS_TARGETS} PARENT_SCOPE)

=== debian/changelog ===
libiio (0.10-3) unstable; urgency=medium

  * Add libserialport and libusb build dependencies
  * limit cil architectures

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 05 Sep 2017 21:07:13 -0400

libiio (0.10-2) unstable; urgency=medium

  * linux-only iiod
  * Adopt package

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 05 Sep 2017 20:34:24 -0400

libiio (0.10-1) unstable; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 23 Aug 2017 22:14:36 -0400

=== debian/control ===
Source: libiio
Section: libs
Priority: optional
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: bison,
	       cli-common-dev [amd64 arm64 armel armhf i386 mipsel ppc64el s390x kfreebsd-any powerpc ppc64],
               cmake (>= 2.8),
               debhelper (>= 9),
               dh-python,
               doxygen,
               flex,
	       libserialport-dev,
	       libudev-dev [linux-any],
	       libusb-1.0-0-dev [linux-any],
	       libusb2-dev [kfreebsd-any],
	       libxml2-dev,
               python
Standards-Version: 4.1.0
Homepage: https://github.com/analogdevicesinc/libiio
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libiio.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/libiio.git

Package: libiio0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: avahi-daemon
Description: Library for interfacing with IIO devices
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains the shared library.

Package: libiio-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libiio0 (= ${binary:Version}), ${misc:Depends}
Description: libiio development files
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains the development files.

Package: iiod
Architecture: linux-any
Depends: libiio0 (>= ${binary:Version}),
         lsb-base (>=3.0-6),
         ${misc:Depends},
         ${shlibs:Depends}
Section: net
Suggests: avahi-daemon
Description: Daemon to share IIO devices on the network
 IIOD is a network daemon that communicates with the network backend of libiio.
 It can be used, for instance, to stream the flow of data samples from one weak
 system to a more powerful one, where the samples will be processed.

Package: libiio-utils
Architecture: any
Depends: libiio0 (>= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Miscellaneous libiio utilities
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains several basic utilities for testing libiio.

Package: python-libiio
Section: python
Architecture: all
Depends: libiio0 (>= ${binary:Version}), ${misc:Depends}, ${python:Depends}
Description: Python bindings for libiio
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains the Python bindings for libiio.

Package: libiio0-cil
Section: cli-mono
Architecture: amd64 arm64 armel armhf i386 mipsel ppc64el s390x kfreebsd-any powerpc ppc64
Depends: libiio0 (>= ${binary:Version}), ${cli:Depends}, ${misc:Depends}
Description: CLI bindings for libiio
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains the CLI bindings for libiio.

Package: libiio-cil-dev
Section: cli-mono
Architecture: amd64 arm64 armel armhf i386 mipsel ppc64el s390x kfreebsd-any powerpc ppc64
Depends: libiio0-cil (>= ${source:Upstream-Version}),
         libiio0-cil (<< ${source:Upstream-Version}+1~),
         ${misc:Depends}
Description: CLI bindings for libiio (development)
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains development files for the CLI bindings of libiio,
 and should be used for compilation.

Package: libiio0-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, ${misc:Depends}
Description: libiio documentation
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains the documentation in HTML format.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --parallel --with python2

override_dh_auto_configure:
	dh_auto_configure -- -DINSTALL_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_compress:
	dh_compress -X.c -X.C

override_dh_clistrip:
	dh_clistrip --exclude=mdb

override_dh_auto_install:
	dh_auto_install
	# jquery.js is provided in another debian package, do not ship one here too
	- rm debian/tmp/usr/share/doc/libiio0-doc/html/jquery.js
	ln -s /usr/share/javascript/jquery/jquery.js debian/tmp/usr/share/doc/libiio0-doc/html/jquery.js

## libiio 0.15

=== debian/changelog ===
libiio (0.15-1) unstable; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 13 May 2018 11:00:37 -0400

libiio (0.14-1) unstable; urgency=medium

  * New upstream, update to v0.14-15-g8ac1893
  * Remove cil components while Mono is broken on Debian

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 07 Apr 2018 21:40:53 -0400

libiio (0.11-1) unstable; urgency=medium

  * New upstream release
    Add quiet mode to iio_attr
    Don't clear local channel enabled state on buffer destruction
       in the local backend
    Code style cleanups in iio_attr and ad9361-iiostream
	    
 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 15 Nov 2017 23:43:54 -0500

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,7 @@
 Priority: optional
 Maintainer: A. Maitland Bottoms <bottoms@debian.org>
 Build-Depends: bison,
-	       cli-common-dev [amd64 arm64 armel armhf i386 mipsel ppc64el s390x kfreebsd-any powerpc ppc64],
-               cmake (>= 2.8),
+               cmake,
                debhelper (>= 9),
                dh-python,
                doxygen,
@@ -14,11 +13,11 @@
 	       libusb-1.0-0-dev [linux-any],
 	       libusb2-dev [kfreebsd-any],
 	       libxml2-dev,
-               python
-Standards-Version: 4.1.0
+               python-dev
+Standards-Version: 4.1.4
 Homepage: https://github.com/analogdevicesinc/libiio
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libiio.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/libiio.git
+Vcs-Browser: https://salsa.debian.org/debian/libiio
+Vcs-Git: https://salsa.debian.org/debian/libiio.git
 
 Package: libiio0
 Architecture: any
@@ -79,31 +78,6 @@
  .
  This package contains the Python bindings for libiio.
 
-Package: libiio0-cil
-Section: cli-mono
-Architecture: amd64 arm64 armel armhf i386 mipsel ppc64el s390x kfreebsd-any powerpc ppc64
-Depends: libiio0 (>= ${binary:Version}), ${cli:Depends}, ${misc:Depends}
-Description: CLI bindings for libiio
- Libiio is a library that has been conceived to ease the development of
- applications interfacing Industrial Input/Output (IIO) devices through
- the IIO subsystem of the Linux kernel.
- .
- This package contains the CLI bindings for libiio.
-
-Package: libiio-cil-dev
-Section: cli-mono
-Architecture: amd64 arm64 armel armhf i386 mipsel ppc64el s390x kfreebsd-any powerpc ppc64
-Depends: libiio0-cil (>= ${source:Upstream-Version}),
-         libiio0-cil (<< ${source:Upstream-Version}+1~),
-         ${misc:Depends}
-Description: CLI bindings for libiio (development)
- Libiio is a library that has been conceived to ease the development of
- applications interfacing Industrial Input/Output (IIO) devices through
- the IIO subsystem of the Linux kernel.
- .
- This package contains development files for the CLI bindings of libiio,
- and should be used for compilation.
-
 Package: libiio0-doc
 Section: doc
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with python2 --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DINSTALL_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_compress:
	dh_compress -X.c -X.C

#override_dh_clistrip:
#	dh_clistrip --exclude=mdb

## libiio 0.16

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,8 +2,11 @@
 project(libiio C)
 
 set(LIBIIO_VERSION_MAJOR 0)
-set(LIBIIO_VERSION_MINOR 10)
+set(LIBIIO_VERSION_MINOR 16)
 set(VERSION "${LIBIIO_VERSION_MAJOR}.${LIBIIO_VERSION_MINOR}")
+if (WIN32)
+	string(TIMESTAMP BUILD_YEAR "%Y")
+endif()
 
 # Set the default install path to /usr
 if (NOT WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
@@ -12,6 +15,10 @@
 
 set(CMAKE_INSTALL_DOCDIR "" CACHE PATH "documentation root (DATAROOTDIR/doc/${PROJECT_NAME}${LIBIIO_VERSION_MAJOR}-doc)")
 include(GNUInstallDirs)
+if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
+	set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_FULL_LIBDIR}")
+	set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+endif()
 set(CMAKE_INSTALL_DOCDIR "${CMAKE_INSTALL_DATAROOTDIR}/doc/${PROJECT_NAME}${LIBIIO_VERSION_MAJOR}-doc")
 
 set(INSTALL_PKGCONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
@@ -96,7 +103,7 @@
 	endif()
 endif()
 
-set(LIBIIO_CFILES backend.c channel.c device.c context.c buffer.c utilities.c scan.c)
+set(LIBIIO_CFILES backend.c channel.c device.c context.c buffer.c utilities.c scan.c sort.c)
 set(LIBIIO_HEADERS iio.h)
 
 add_definitions(-D_POSIX_C_SOURCE=200809L -D__XSI_VISIBLE=500 -DLIBIIO_EXPORTS=1)
@@ -109,9 +116,10 @@
 		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
 		OUTPUT_VARIABLE LIBIIO_GIT_REPO
 		OUTPUT_STRIP_TRAILING_WHITESPACE
+		ERROR_QUIET
 	)
 
-	if (${LIBIIO_GIT_REPO} MATCHES ${CMAKE_CURRENT_SOURCE_DIR})
+	if ("${LIBIIO_GIT_REPO}" STREQUAL "${CMAKE_CURRENT_SOURCE_DIR}")
 		execute_process(
 			COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
 			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
@@ -120,6 +128,9 @@
 		)
 	endif()
 endif()
+
+set(LIBIIO_VERSION  ${VERSION}.g${LIBIIO_VERSION_GIT})
+file(WRITE ${CMAKE_BINARY_DIR}/.version ${LIBIIO_VERSION})
 
 if (NOT LIBIIO_VERSION_GIT)
 	set(LIBIIO_VERSION_GIT v${VERSION})
@@ -151,6 +162,7 @@
 find_library(LIBUSB_LIBRARIES usb-1.0)
 find_path(LIBUSB_INCLUDE_DIR libusb-1.0/libusb.h)
 if (LIBUSB_LIBRARIES AND LIBUSB_INCLUDE_DIR)
+	message(STATUS "Looking for libusb-1.0 : Found")
 	option(WITH_USB_BACKEND "Enable the libusb backend" ON)
 
 	if(WITH_USB_BACKEND)
@@ -162,7 +174,16 @@
 		set(NEED_THREADS 1)
 
 		include_directories(${LIBUSB_INCLUDE_DIR})
-	endif()
+
+		set(TEMP ${CMAKE_REQUIRED_LIBRARIES})
+		set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES}
+			 ${LIBUSB_LIBRARIES})
+		check_symbol_exists(libusb_get_version "libusb-1.0/libusb.h"
+			HAS_LIBUSB_GETVERSION)
+		set(CMAKE_REQUIRED_LIBRARIES ${TEMP})
+	endif()
+else()
+	message(STATUS "Looking for libusb-1.0 : Failed; building without usb")
 endif()
 
 find_library(LIBSERIALPORT_LIBRARIES serialport)
@@ -174,18 +195,19 @@
 		file(STRINGS ${LIBSERIALPORT_INCLUDE_DIR}/libserialport.h LIBSERIALPORT_VERSION_STR REGEX "SP_PACKAGE_VERSION_STRING")
 		string(REGEX REPLACE "#define SP_PACKAGE_VERSION_STRING \"(.*)\"" "\\1" LIBSERIALPORT_VERSION ${LIBSERIALPORT_VERSION_STR})
 		if ("${LIBSERIALPORT_VERSION}" VERSION_LESS 0.1.1)
-			message(SEND_ERROR "The installed version of libserialport is too old. The minimum version supported is 0.1.1.")
+			message(WARNING "The installed version of libserialport is too old. The minimum version supported is 0.1.1. Disabling Serial support.")
+			SET(WITH_SERIAL_BACKEND OFF)
+		else()
+			add_definitions(-DSERIAL_BACKEND=1)
+			set(LIBIIO_CFILES ${LIBIIO_CFILES} serial.c)
+			set(LIBS_TO_LINK ${LIBS_TO_LINK} ${LIBSERIALPORT_LIBRARIES})
+
+			set(NEED_THREADS 1)
+			set(IIOD_CLIENT 1)
+			set(NEED_LIBXML2 1)
+
+			include_directories(${LIBSERIALPORT_INCLUDE_DIR})
 		endif()
-
-		add_definitions(-DSERIAL_BACKEND=1)
-		set(LIBIIO_CFILES ${LIBIIO_CFILES} serial.c)
-		set(LIBS_TO_LINK ${LIBS_TO_LINK} ${LIBSERIALPORT_LIBRARIES})
-
-		set(NEED_THREADS 1)
-		set(IIOD_CLIENT 1)
-		set(NEED_LIBXML2 1)
-
-		include_directories(${LIBSERIALPORT_INCLUDE_DIR})
 	endif()
 endif()
 
@@ -242,7 +264,7 @@
 endif()
 
 if (LIBXML2_FOUND)
-	option(WITH_XML_BACKEND "Enable the serial backend" ON)
+	option(WITH_XML_BACKEND "Enable the XML backend" ON)
 
 	if (WITH_XML_BACKEND)
 		set(LIBIIO_CFILES ${LIBIIO_CFILES} xml.c)
@@ -299,7 +321,13 @@
 	add_subdirectory(tests)
 endif()
 
-add_library(iio ${LIBIIO_CFILES} ${LIBIIO_HEADERS} ${LIBIIO_EXTRA_HEADERS})
+if (WIN32)
+	set(LIBIIO_ORIGINAL_FILENAME libiio.dll)
+	set(LIBIIO_RC ${CMAKE_CURRENT_BINARY_DIR}/properties.rc)
+	configure_file(properties.rc.cmakein ${LIBIIO_RC} @ONLY)
+endif()
+
+add_library(iio ${LIBIIO_CFILES} ${LIBIIO_HEADERS} ${LIBIIO_EXTRA_HEADERS} ${LIBIIO_RC})
 set_target_properties(iio PROPERTIES
 	VERSION ${VERSION}
 	SOVERSION ${LIBIIO_VERSION_MAJOR}
@@ -328,6 +356,16 @@
 if(DOXYGEN_FOUND)
 	option(WITH_DOC "Generate documentation with Doxygen" ON)
 
+	# It is not an error when 'dot' is not found, just switching off the Doxygen's HAVE_DOT option
+	find_package_handle_standard_args (Dot REQUIRED_VARS DOXYGEN_DOT_EXECUTABLE)
+
+	include(cmake/CheckCaseSensitiveFileSystem.cmake)
+	if (HAVE_CASE_SENSITIVE_FILESYSTEM)
+		set(CMAKE_CASE_SENSITIVE_FILESYSTEM "YES")
+	else()
+		set(CMAKE_CASE_SENSITIVE_FILESYSTEM "NO")
+	endif()
+
 	if (WITH_DOC)
 		configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
 		set(HTML_DEST_DIR ${CMAKE_CURRENT_BINARY_DIR}/html)
@@ -335,41 +373,3 @@
 
 		add_custom_command(TARGET iio POST_BUILD
 			COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
-			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
-			COMMENT "Generating API documentation with Doxygen" VERBATIM
-			)
-
-		if(NOT SKIP_INSTALL_ALL)
-			install(DIRECTORY ${HTML_DEST_DIR} DESTINATION ${CMAKE_INSTALL_DOCDIR})
-		endif()
-	endif()
-else()
-	message(STATUS "Doxygen not found, API documentation won't be generated")
-endif()
-
-# Create an installer if compiling for OSX
-if(OSX_PACKAGE)
-	set(LIBIIO_PKG ${CMAKE_CURRENT_BINARY_DIR}/libiio-${VERSION}.g${LIBIIO_VERSION_GIT}.pkg)
-	set(LIBIIO_TEMP_PKG ${CMAKE_CURRENT_BINARY_DIR}/libiio-${VERSION}-temp.pkg)
-	set(LIBIIO_DISTRIBUTION_XML ${CMAKE_CURRENT_BINARY_DIR}/Distribution.xml)
-	set(LIBIIO_FRAMEWORK_DIR ${CMAKE_CURRENT_BINARY_DIR}/iio.framework)
-	configure_file(Distribution.xml.cmakein ${LIBIIO_DISTRIBUTION_XML} @ONLY)
-
-	find_program(PKGBUILD_EXECUTABLE
-		NAMES pkgbuild
-		DOC "OSX Package builder (pkgbuild)")
-	mark_as_advanced(PKGBUILD_EXECUTABLE)
-
-	find_program(PRODUCTBUILD_EXECUTABLE
-		NAMES productbuild
-		DOC "OSX Package builder (productbuild)")
-	mark_as_advanced(PRODUCTBUILD_EXECUTABLE)
-
-	foreach(_tool ${IIO_TESTS_TARGETS})
-		list(APPEND IIO_TESTS $<TARGET_FILE:${_tool}>)
-	endforeach()
-
-	add_custom_command(OUTPUT ${LIBIIO_PKG}
-		COMMAND ${CMAKE_COMMAND} -E make_directory ${LIBIIO_FRAMEWORK_DIR}/Tools
-		COMMAND ${CMAKE_COMMAND} -E copy ${IIO_TESTS} ${LIBIIO_FRAMEWORK_DIR}/Tools
-		COMMAND ${PKGBUILD_EXECUTABLE}

=== iiod/CMakeLists.txt ===
--- 
+++ 
@@ -62,3 +62,20 @@
 if(NOT SKIP_INSTALL_ALL)
 	install(TARGETS iiod RUNTIME DESTINATION ${CMAKE_INSTALL_SBINDIR})
 endif()
+
+if (WITH_SYSTEMD)
+	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/init/iiod.service.cmakein ${PROJECT_BINARY_DIR}/init/iiod.service)
+	install(FILES ${PROJECT_BINARY_DIR}/init/iiod.service DESTINATION ${SYSTEMD_UNIT_INSTALL_DIR})
+endif()
+
+if (WITH_SYSVINIT)
+	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/init/iiod.init.cmakein ${PROJECT_BINARY_DIR}/init/iiod)
+	install(FILES ${PROJECT_BINARY_DIR}/init/iiod
+	        PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
+	        DESTINATION ${SYSVINIT_INSTALL_DIR})
+endif()
+
+if (WITH_UPSTART)
+	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/init/iiod.conf.cmakein ${PROJECT_BINARY_DIR}/init/iiod.conf)
+	install(FILES ${PROJECT_BINARY_DIR}/init/iiod.conf DESTINATION ${UPSTART_CONF_INSTALL_DIR})
+endif()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -11,19 +11,26 @@
 	set(GETOPT_C_FILE ${CMAKE_CURRENT_SOURCE_DIR}/../deps/wingetopt/src/getopt.c)
 endif (MSVC)
 
-add_executable(iio_genxml  iio_genxml.c   ${GETOPT_C_FILE})
-add_executable(iio_info    iio_info.c     ${GETOPT_C_FILE})
-add_executable(iio_attr    iio_attr.c     ${GETOPT_C_FILE})
-add_executable(iio_readdev iio_readdev.c  ${GETOPT_C_FILE})
-add_executable(iio_reg     iio_reg.c      ${GETOPT_C_FILE})
+if (WIN32)
+	set(LIBIIO_ORIGINAL_FILENAME )
+	set(LIBIIO_RC ${CMAKE_CURRENT_BINARY_DIR}/properties.rc)
+	configure_file(../properties.rc.cmakein ${LIBIIO_RC} @ONLY)
+endif()
+add_executable(iio_genxml  iio_genxml.c   ${GETOPT_C_FILE} ${LIBIIO_RC})
+add_executable(iio_info    iio_info.c     ${GETOPT_C_FILE} ${LIBIIO_RC})
+add_executable(iio_attr    iio_attr.c     ${GETOPT_C_FILE} ${LIBIIO_RC})
+add_executable(iio_readdev iio_readdev.c  ${GETOPT_C_FILE} ${LIBIIO_RC})
+add_executable(iio_reg     iio_reg.c      ${GETOPT_C_FILE} ${LIBIIO_RC})
+add_executable(iio_writedev iio_writedev.c  ${GETOPT_C_FILE} ${LIBIIO_RC})
 
 target_link_libraries(iio_genxml  iio)
 target_link_libraries(iio_info    iio)
 target_link_libraries(iio_attr    iio)
 target_link_libraries(iio_readdev iio)
 target_link_libraries(iio_reg     iio)
+target_link_libraries(iio_writedev iio)
 
-set(IIO_TESTS_TARGETS iio_genxml iio_info iio_attr iio_readdev iio_reg)
+set(IIO_TESTS_TARGETS iio_genxml iio_info iio_attr iio_readdev iio_reg iio_writedev)
 
 if(PTHREAD_LIBRARIES)
 	project(iio_adi_xflow_check C)
@@ -31,7 +38,8 @@
 	target_link_libraries(iio_adi_xflow_check iio ${PTHREAD_LIBRARIES})
 	set(IIO_TESTS_TARGETS ${IIO_TESTS_TARGETS} iio_adi_xflow_check)
 
-	target_link_libraries(iio_readdev ${PTHREAD_LIBRARIES})
+	target_link_libraries(iio_readdev  ${PTHREAD_LIBRARIES})
+	target_link_libraries(iio_writedev ${PTHREAD_LIBRARIES})
 endif()
 
 set_target_properties(${IIO_TESTS_TARGETS} PROPERTIES

=== debian/changelog ===
libiio (0.16-1) unstable; urgency=medium

  * New upstream release
  * Build for default Python3 (Closes: #913411, #912166)

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 22 Nov 2018 10:02:41 -0500

libiio (0.15-4) unstable; urgency=medium

  * Update to v0.15-47-ged6709e

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 08 Nov 2018 21:20:51 -0500

libiio (0.15-3) experimental; urgency=medium

  * upload to experimental waiting for NEW python3-libiio
  * add python3-iio package (Closes: #896905)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 24 Sep 2018 20:32:03 -0400

libiio (0.15-2.1) UNRELEASED; urgency=medium

  * d/copyright: Use https protocol in Format field
  * d/changelog: Remove trailing whitespaces

 -- Ondřej Nový <onovy@debian.org>  Mon, 01 Oct 2018 10:06:53 +0200

libiio (0.15-2) unstable; urgency=medium

  * Update to v0.15-6-gc80412c
  * install all utils
  * install udev rules

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 18 Sep 2018 19:13:32 -0700

=== debian/control ===
--- 
+++ 
@@ -13,8 +13,9 @@
 	       libusb-1.0-0-dev [linux-any],
 	       libusb2-dev [kfreebsd-any],
 	       libxml2-dev,
-               python-dev
-Standards-Version: 4.1.4
+               python-dev,
+	       python3-dev
+Standards-Version: 4.2.1
 Homepage: https://github.com/analogdevicesinc/libiio
 Vcs-Browser: https://salsa.debian.org/debian/libiio
 Vcs-Git: https://salsa.debian.org/debian/libiio.git
@@ -70,7 +71,18 @@
 Package: python-libiio
 Section: python
 Architecture: all
-Depends: libiio0 (>= ${binary:Version}), ${misc:Depends}, ${python:Depends}
+Depends: python, libiio0 (>= ${binary:Version}), ${misc:Depends}, ${python:Depends}
+Description: Python bindings for libiio
+ Libiio is a library that has been conceived to ease the development of
+ applications interfacing Industrial Input/Output (IIO) devices through
+ the IIO subsystem of the Linux kernel.
+ .
+ This package contains the Python bindings for libiio.
+
+Package: python3-libiio
+Section: python
+Architecture: all
+Depends: libiio0 (>= ${binary:Version}), ${misc:Depends}, ${python3:Depends}
 Description: Python bindings for libiio
  Libiio is a library that has been conceived to ease the development of
  applications interfacing Industrial Input/Output (IIO) devices through

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --builddirectory=build --with python2 --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_INSTALL_RPATH=On

override_dh_auto_build:
	dh_auto_build
	python3 build/bindings/python/setup.py build

override_dh_auto_install:
	dh_auto_install
	python3 build/bindings/python/setup.py install --root=debian/tmp/ --prefix=/usr

override_dh_compress:
	dh_compress -X.c -X.C

#override_dh_clistrip:
#	dh_clistrip --exclude=mdb

## libiio 0.18

=== debian/changelog ===
libiio (0.18-2) unstable; urgency=medium

  * No more Python2 (Closes: #936876)
  * reproducuble documentation (Closes: #922520)

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 15 Nov 2019 20:50:58 -0500

libiio (0.18-1) unstable; urgency=medium

  * New upstream release
  * update to v0.18-16-gc0012d0

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 14 Aug 2019 21:34:58 -0400

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: A. Maitland Bottoms <bottoms@debian.org>
 Build-Depends: bison,
                cmake,
-               debhelper (>= 9),
+               debhelper (>= 12),
                dh-python,
                doxygen,
                flex,
@@ -13,9 +13,8 @@
 	       libusb-1.0-0-dev [linux-any],
 	       libusb2-dev [kfreebsd-any],
 	       libxml2-dev,
-               python-dev,
 	       python3-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.4.0
 Homepage: https://github.com/analogdevicesinc/libiio
 Vcs-Browser: https://salsa.debian.org/debian/libiio
 Vcs-Git: https://salsa.debian.org/debian/libiio.git
@@ -47,9 +46,10 @@
 
 Package: iiod
 Architecture: linux-any
+Pre-Depends: ${misc:Pre-Depends}
 Depends: libiio0 (>= ${binary:Version}),
          lsb-base (>=3.0-6),
-         ${misc:Depends},
+	 ${misc:Depends},
          ${shlibs:Depends}
 Section: net
 Suggests: avahi-daemon
@@ -67,17 +67,6 @@
  the IIO subsystem of the Linux kernel.
  .
  This package contains several basic utilities for testing libiio.
-
-Package: python-libiio
-Section: python
-Architecture: all
-Depends: python, libiio0 (>= ${binary:Version}), ${misc:Depends}, ${python:Depends}
-Description: Python bindings for libiio
- Libiio is a library that has been conceived to ease the development of
- applications interfacing Industrial Input/Output (IIO) devices through
- the IIO subsystem of the Linux kernel.
- .
- This package contains the Python bindings for libiio.
 
 Package: python3-libiio
 Section: python

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --builddirectory=build --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_INSTALL_RPATH=On

override_dh_compress:
	dh_compress -X.c -X.C
